package lab07_solutions;

import java.util.LinkedList;
import java.util.Random;


public class TestBinaryTree {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		BinaryTree testTree = new BinaryTree();
		Random r = new Random();
		
		int insertedV[] = new int[10];
		LinkedList<Integer> toCompareWith =  new LinkedList<Integer>();
		
		for(int i=0; i<1000000; i++) {
			int value = r.nextInt();
			testTree.insert(value);
			toCompareWith.add(value);
			if( i % 100000 == 0) {
				insertedV[ i/100000 ] = value;
			}
		}
		
		System.out.println("Tree height is: " + testTree.getHeight() );
		System.out.println("Tree holds " + testTree.getSize() + " integers" );
		System.out.println("Tree values are in the range of [" + testTree.getMin() + ", " + testTree.getMax() + "]");

		System.out.println("Searching test");
		
		System.out.println("\t\tList\tTree\t(ms)");
		for(int i = 0; i < insertedV.length; i++) {
			int value = insertedV[i];
			long start1 = System.currentTimeMillis();
			
			if(!toCompareWith.contains(value) ) {
				System.out.println("Error, "+value+" is not in the list");
			}
			
			long start2 = System.currentTimeMillis();
			if ( !testTree.lookup(value) ) {
				System.out.println("Error, "+value+" is not in the tree");
			}
			
			long end = System.currentTimeMillis();
			
			System.out.println(i+":"+value+"\t"+(start2 - start1) +"\t" + (end - start2) );
		}
		
/********* Example Output *********************
		
Tree height is: 51
Tree holds 1000000 integers
Tree values are in the range of [-2147483027, 2147479909]
Searching test
			List	Tree	(ms)
0:635477680		0	0
1:508147331		3	0
2:1323424275	1	0
3:1218304360	1	0
4:-661096310	2	0
5:1109684098	2	0
6:-572626345	3	0
7:-1648424686	4	0
8:-164831302	4	0
9:-1408338345	5	0

************************************************/
	}

}
